VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPacket"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'---------------------------------------
' Packet Class
' o Handles all incoming and outgoing data
' o Deconstructs/Constructs packets into the correct sequence for sending
'---------------------------------------

Private sOutbound As String, sInbound As String, sPosition As Long

Public Sub ClearOut()
    sOutbound = vbNullString
End Sub

Public Sub ClearIn()
    sInbound = vbNullString
    sPosition = 1
End Sub

Public Sub InsertBYTE(ByVal Value As Byte)
    sOutbound = sOutbound & Chr$(Value)
End Sub

Public Sub InsertWORD(ByVal Value As Integer)
    Dim NewValue As String * 2
    CopyMemory ByVal NewValue, Value, 2
    sOutbound = sOutbound & NewValue
End Sub

Public Sub InsertDWORD(ByVal Value As Long)
    Dim NewValue As String * 4
    CopyMemory ByVal NewValue, Value, 4
    sOutbound = sOutbound & NewValue
End Sub

Public Sub InsertBSTR(ByVal Value As String)
    sOutbound = sOutbound & Value
End Sub

Public Sub InsertCSTR(ByVal Value As String)
    sOutbound = sOutbound & Value & vbNullChar
End Sub

Public Sub SendData()
    If frmMain.wsBNCS.State = sckConnected Then
        frmMain.wsBNCS.SendData sOutbound
        sOutbound = vbNullString
    End If
End Sub

Public Sub SendPacket(ByVal ID As Byte, Optional UseBNLS As Boolean = False)
    'On Error Resume Next
    Dim NewValue As String * 2
    If UseBNLS = False Then
        If frmMain.wsBNCS.State = sckConnected Then
            CopyMemory ByVal NewValue, (Len(sOutbound) + 4), 2
            frmMain.wsBNCS.SendData Chr$(&HFF) & Chr$(ID) & NewValue & sOutbound
            If Err Then
                AddChat vbRed, "Error occurred in sending packet " & Hex(ID) & "."
            End If
        End If
        Debug.Print ">> BNCS: " & Hex(ID)
    Else
        If frmMain.wsBNLS.State = sckConnected Then
            CopyMemory ByVal NewValue, (Len(sOutbound) + 3), 2
            frmMain.wsBNLS.SendData NewValue & Chr$(ID) & sOutbound
            If Err Then
                AddChat vbRed, "Error occurred in sending BNLS packet " & Hex(ID) & "."
            End If
        End If
        Debug.Print ">> BNLS: " & Hex(ID)
    End If
    'AddChat vbCyan, "C=>S: " & Hex(ID)
    sOutbound = vbNullString
End Sub

Public Sub SetData(ByVal Value As String)
    sInbound = Value
    sPosition = 1
End Sub

Public Function GetDATA() As String
    GetDATA = sInbound
End Function

Public Function Skip(ByVal Bytes As Long)
    sPosition = sPosition + Bytes
End Function

Public Function GetBYTE() As Byte
    GetBYTE = Asc(Mid$(sInbound, sPosition, 1))
    sPosition = sPosition + 1
End Function

Public Function GetWORD() As Integer
    Dim NewValue As Integer
    CopyMemory NewValue, ByVal Mid$(sInbound, sPosition, 2), 2
    GetWORD = NewValue
    sPosition = sPosition + 2
End Function

Public Function GetDWORD() As Long
    Dim NewValue As Long
    CopyMemory NewValue, ByVal Mid$(sInbound, sPosition, 4), 4
    GetDWORD = NewValue
    sPosition = sPosition + 4
End Function

Public Function GetBSTR(ByVal Value As Integer) As String
    GetBSTR = Mid$(sInbound, sPosition, Value)
    sPosition = sPosition + Len(GetBSTR)
End Function

Public Function GetCSTR() As String
    GetCSTR = Split(Mid$(sInbound, sPosition), vbNullChar)(0)
    sPosition = sPosition + Len(GetCSTR) + 1
End Function
